#!/usr/bin/perl

use string_aligner;

open(DICT,"numbers+syl.dict");
while(<DICT>) {
    chop;
    ($word,@phones)=split;
    $mrk="O";
    @syls=();
    for($i=0;$i<=$#phones;) {
	if ($phones[$i] eq "+") {
	    splice(@phones,$i,1);
	    $mrk="O";
	    next;
	} elsif ($phones[$i] eq "h#") {
	    push(@syls,"X");
	    $mrk="O";
	} elsif ($phones[$i] =~ /^[aeiou]/) {
	    push(@syls,"N");
	    $mrk="C";
	} else {
	    push(@syls,$mrk);
	}
	$i++;
    }
    $dict{$word}=[@phones];
    $syls{$word}=[@syls];
}




close(DICT);

open(RILEY,"riley-feats");
while(<RILEY>) {
    chop;
    @feats=split;
    $phone=shift(@feats);
    $feats{$phone}=join(" ",@feats);
}
close(RILEY);
    
$aligner=new string_aligner("phonedist");

$list=shift(@ARGV);

open(PHNFILES,"numbers95_findfile filetype=phnfile prefix=/u/drspeech/data/numbers95 utfile=$list|");
open(WRDFILES,"numbers95_findfile filetype=wrdfile prefix=/u/drspeech/data/numbers95 utfile=$list|");

while(<WRDFILES>) {
    print STDERR $_;
    chop;
    @words=();
    open(WRDFILE,$_) || die("Can't open $_ for reading");
    while(<WRDFILE>) {
	chop;
	push(@words,split);
    }
    close(WRDFILE);

    @phones=();
    @wordmarks=();
    @wordstarts=();
    @sylmrks=();
    foreach $w (@words) {
	$w=~s/\*$//;
	@tmp=@{$dict{$w}};
	$ws=1;
	for($i=0;$i<=$#tmp;$i++) {
	    push(@wordmarks,$w);
	    push(@wordstarts,$ws);
	    $ws=0;
	}
	push(@phones,@tmp);
	push(@sylmrks,@{$syls{$w}});
    }

    @realphones=();
    $_=<PHNFILES>;
    open(PHNFILE,$_) || die("Can't open $_ for reading");
    while(<PHNFILE>) {
	chop;
	($start,$stop,$phone)=split;
	push(@realphones,$phone);
    }
    close(PHNFILE);
    
    @backtrace=$aligner->align(\@phones,\@realphones);

    $j=0;
    $k=0;
    for($i=0;$i<=$#backtrace;$i++) {
	if ($backtrace[$i] eq "COR" || $backtrace[$i] eq "SUB") {
	    $j++; $k++;
	} elsif ($backtrace[$i] eq "INS") {
	    if ($realphones[$k] eq "h#") {
		#splice(@realphones,$k,1);
		splice(@phones,$j,0,"h#");
		splice(@wordmarks,$j,0,"SIL");
		splice(@sylmrks,$j,0,"X");
		$j++; $k++;
	    } else {
		($p)=splice(@realphones,$k,1);
#		print "$p: $phones[$j-1] or $phones[$j]\n";
#		print $aligner->phonedist_cost($p,$phones[$j-1]),"\n";
#		print $aligner->phonedist_cost($p,$phones[$j]),"\n";
		if ($k>$#realphones) {
		    $realphones[$k-1].="_$p";
		} elsif ($k==0 || 
			 $aligner->phonedist_cost($p,$phones[$j]) <
			 $aligner->phonedist_cost($p,$phones[$j-1])) {
		    $realphones[$k]=$p."_".$realphones[$k];
		} else {
		    $realphones[$k-1].="_$p";
		}
	    }
	} elsif ($backtrace[$i] eq "DEL") {
	    splice(@realphones,$k,0,"NULL");
	    $j++; $k++;
	}
    }

    if ($phones[0] ne "h#") {
	unshift(@phones,"h#");
	unshift(@realphones,"h#");
	unshift(@wordmarks,"SIL");
	unshift(@wordstarts,1);
	unshift(@sylmrks,"X");
    }
    if ($phones[$#phones] ne "h#") {
	push(@phones,"h#");
	push(@realphones,"h#");
	push(@wordmarks,"SIL");
	push(@wordstarts,1);
	push(@sylmrks,"X");
    }

    @leftboundary=();
    for($i=0;$i<=$#phones;$i++) {
	$counter=0 if ($wordstarts[$i]);
	$leftboundary[$i]=$counter++;
    }
    @rightboundary=();
    $counter=0;
    for($i=$#phones;$i>=0;$i--) {
	$rightboundary[$i]=$counter++;
	$counter=0 if ($wordstarts[$i]);
    }

    for ($i=1;$i<$#phones;$i++) {
	print join (" ",@phones[$i-1..$i+1],@sylmrks[$i-1..$i+1],@wordmarks[$i-1..$i+1],$leftboundary[$i],$rightboundary[$i],$feats{$phones[$i-1]},$feats{$phones[$i+1]},$realphones[$i]),"\n";
    }

#    print join(" ",@phones),"\n";
#    print join(" ",@realphones),"\n";
}
	
close(WRDFILES);
close(PHNFILES);


